//==============================================================================
//	
//	Copyright (c) 2011-
//	Authors:
//	* Christian Krause <christian.krause@hpi.uni-potsdam.de> (Hasso Plattner Institute)
//	
//------------------------------------------------------------------------------
//	
//	This file is part of PRISM.
//	
//	PRISM is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//	
//	PRISM is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//	
//	You should have received a copy of the GNU General Public License
//	along with PRISM; if not, write to the Free Software Foundation,
//	Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//	
//==============================================================================

package ipta;

import explicit.Distribution;
import explicit.IntervalDistribution;
import pta.Edge;
import pta.PTAAbstractRefine;
import pta.SymbolicTransition;

public class IPTAAbstractRefine extends PTAAbstractRefine {
	
	/*
	 * (non-Javadoc)
	 * @see pta.PTAAbstractRefine#createDistribution(pta.SymbolicTransition)
	 */
	@Override
	protected Distribution createDistribution(SymbolicTransition symbolic) {
		IntervalDistribution distr = new IntervalDistribution();
		int count = 0;
		for (Edge edge : symbolic.tr.getEdges()) {
			int dest = symbolic.dests[count];
			if (dest!=-1) {
				if (edge instanceof IntervalEdge) {
					IntervalEdge intervalEdge = (IntervalEdge) edge;
					distr.add(dest, intervalEdge.getLowerBound(), intervalEdge.getUpperBound());
				} else {
					distr.add(dest, edge.getProbability(), edge.getProbability());
				}
			}
			count++;
		}
		return distr;
	}
	
}
