/* Generated By:JavaCC: Do not edit this line. IPTAParser.java */
package ipta.parser;

import java.io.*;
import java.util.*;

import pta.*;
import pta.parser.*;
import ipta.*;
import prism.PrismLangException;

public class IPTAParser implements IPTAParserConstants {

        // Parse IPTA

        public IPTA parseIPTA(InputStream str) throws PrismLangException
        {
                astIPTA ipta = null;

                // (Re)start parser
                ReInit(str);
                // Parse
                try {
                        ipta = IPTA();
                }
                catch (ParseException e) {
                        throw new PrismLangException(e.getMessage());
                }

                return ipta.createDataStructures();
        }

        //------------------------------------------------------------------------------
        // Abstract syntax tree classes
        //------------------------------------------------------------------------------

        public static class astIPTA extends PTAParser.astPTA
        {
                @Override
                protected IPTA createPTA() {
                        return new IPTA();
                }

                @Override
                public IPTA createDataStructures() {
                        return (IPTA) super.createDataStructures();
                }

                @Override
                public astIntervalTransition addTransition(String locName) {
                        astIntervalTransition t = new astIntervalTransition();
                        transitions.get(locName).add(t);
                        return t;
                }

        }

        static class astIntervalTransition extends PTAParser.astTransition
        {
                public astIntervalEdge addEdge(double lower, double upper, String dest) {
                        astIntervalEdge e = new astIntervalEdge(lower, upper, dest);
                        edges.add(e);
                        return e;
                }
        }

        static class astIntervalEdge extends PTAParser.astEdge
        {
                public double lower, upper;

                public astIntervalEdge(double lower, double upper, String dest) {
                        super(lower, dest);
                        this.lower = lower;
                        this.upper = upper;
                        this.dest = dest;
                        resets = new HashMap<Integer,Integer>();
                }
                public void createDataStructures(astIPTA ipta, IntervalTransition trans)
                {
                        int d = ipta.getLocationIndex(dest);
                        if (d == -1) {
                                System.err.println("Error: Location \u005c""+dest+"\u005c" does not exist");
                                System.exit(1);
                        }
                        Edge edge = trans.addEdge(lower, upper, d);
                        for (Map.Entry<Integer,Integer> e : resets.entrySet()) {
                                edge.addReset(e.getKey(), e.getValue());
                        }
                }
        }

        static class Interval
        {
                double lower, upper;
                Interval(double lower, double upper) {
                        this.lower = lower;
                        this.upper = upper;
                }
        }

//-----------------------------------------------------------------------------------
// Top-level production
//-----------------------------------------------------------------------------------

// IPTA
  static final public astIPTA IPTA() throws ParseException {
        astIPTA ipta = new astIPTA();
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      Location(ipta);
    }
    jj_consume_token(0);
                {if (true) return ipta;}
    throw new Error("Missing return statement in function");
  }

  static final public void Location(astIPTA ipta) throws ParseException {
        String name;
        LinkedHashSet<Constraint> constrs;
    jj_consume_token(LBRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INIT:
      jj_consume_token(INIT);
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
    jj_consume_token(NODE);
    name = Identifier();
                                   ipta.addLocation(name);
    jj_consume_token(SEMICOLON);
    constrs = ConstraintList(ipta);
                                                   ipta.setInvariantConditions(name, constrs);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_2;
      }
      Transition(ipta, name);
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RBRACE:
      jj_consume_token(RBRACE);
      break;
    case TIMES:
      jj_consume_token(TIMES);
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  static final public void Transition(astIPTA ipta, String locName) throws ParseException {
        astIntervalTransition tr;
    jj_consume_token(LBRACKET);
                     tr = ipta.addTransition(locName);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRAN:
      case REG_IDENT:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_3;
      }
      Edge(ipta, tr);
    }
    jj_consume_token(RBRACKET);
  }

  static final public void Edge(astIPTA ipta, astIntervalTransition tr) throws ParseException {
        LinkedHashSet<Constraint> constrs;
        String action = null, dest;
        Interval interval;
        astIntervalEdge edge;
        HashMap<Integer,Integer> resets;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REG_IDENT:
      action = Identifier();
      jj_consume_token(OR);
      jj_consume_token(OR);
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
    jj_consume_token(TRAN);
    dest = Identifier();
    jj_consume_token(SEMICOLON);
    constrs = ConstraintList(ipta);
    jj_consume_token(SEMICOLON);
    resets = Resets(ipta);
    jj_consume_token(SEMICOLON);
    interval = Interval();
                tr.setAction(action);
                edge = tr.addEdge(interval.lower, interval.upper, dest);
                for (Map.Entry<Integer,Integer> e : resets.entrySet()) edge.addReset(e.getKey(), e.getValue());
                for (Constraint c : constrs) tr.addGuardConstraint(c);
  }

  static final public LinkedHashSet<Constraint> ConstraintList(astIPTA ipta) throws ParseException {
        LinkedHashSet<Constraint> constrs = new LinkedHashSet<Constraint>();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REG_IDENT:
      Constraint(ipta, constrs);
      label_4:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[6] = jj_gen;
          break label_4;
        }
        jj_consume_token(COMMA);
        Constraint(ipta, constrs);
      }
      break;
    case TRUE:
      jj_consume_token(TRUE);
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return constrs;}
    throw new Error("Missing return statement in function");
  }

  static final public void Constraint(astIPTA ipta, LinkedHashSet<Constraint> constrs) throws ParseException {
        String clock1Name, clock2Name;
        int clock1, clock2, val;
        Token t;
    clock1Name = Identifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
      t = jj_consume_token(LT);
      break;
    case LE:
      t = jj_consume_token(LE);
      break;
    case GT:
      t = jj_consume_token(GT);
      break;
    case GE:
      t = jj_consume_token(GE);
      break;
    case EQ:
      t = jj_consume_token(EQ);
      break;
    default:
      jj_la1[8] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REG_INT:
      val = Integer();
                clock1 = ipta.getOrAddClock(clock1Name);
                switch (t.kind) {
                case IPTAParserConstants.LT:
                        constrs.add(Constraint.buildLt(clock1, val)); break;
                case IPTAParserConstants.LE:
                        constrs.add(Constraint.buildLeq(clock1, val)); break;
                case IPTAParserConstants.GT:
                        constrs.add(Constraint.buildGt(clock1, val)); break;
                case IPTAParserConstants.GE:
                        constrs.add(Constraint.buildGeq(clock1, val)); break;
                case IPTAParserConstants.EQ:
                        constrs.add(Constraint.buildLeq(clock1, val));
                        constrs.add(Constraint.buildGeq(clock1, val)); break;
                }
      break;
    case REG_IDENT:
      clock2Name = Identifier();
                clock1 = ipta.getOrAddClock(clock1Name);
                clock2 = ipta.getOrAddClock(clock2Name);
                switch (t.kind) {
                case IPTAParserConstants.LT:
                        constrs.add(Constraint.buildLt(clock1, clock2)); break;
                default:
                        System.err.println("Error: Unsupported constraint type"); System.exit(1);
                }
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  static final public HashMap<Integer,Integer> Resets(astIPTA ipta) throws ParseException {
        HashMap<Integer,Integer> resets = new HashMap<Integer,Integer>();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REG_IDENT:
      Reset(ipta, resets);
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[10] = jj_gen;
          break label_5;
        }
        jj_consume_token(COMMA);
        Reset(ipta, resets);
      }
      break;
    case NULL:
      jj_consume_token(NULL);
      break;
    default:
      jj_la1[11] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return resets;}
    throw new Error("Missing return statement in function");
  }

  static final public void Reset(astIPTA ipta, HashMap<Integer,Integer> resets) throws ParseException {
        String clockName;
        int clock;
        int val;
    clockName = Identifier();
    jj_consume_token(EQ);
    val = Integer();
                clock = ipta.getOrAddClock(clockName);
                resets.put(clock, val);
  }

  static final public Interval Interval() throws ParseException {
        Token l,u;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REG_DOUBLE:
      l = jj_consume_token(REG_DOUBLE);
      break;
    case REG_INT:
      l = jj_consume_token(REG_INT);
      break;
    default:
      jj_la1[12] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(SNAKE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REG_DOUBLE:
      u = jj_consume_token(REG_DOUBLE);
      break;
    case REG_INT:
      u = jj_consume_token(REG_INT);
      break;
    default:
      jj_la1[13] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return new Interval(Double.parseDouble(l.image),Double.parseDouble(u.image));}
    throw new Error("Missing return statement in function");
  }

//-----------------------------------------------------------------------------------
// Miscellaneous stuff
//-----------------------------------------------------------------------------------

// Identifier (returns String)
  static final public String Identifier() throws ParseException {
    jj_consume_token(REG_IDENT);
                      {if (true) return getToken(0).image;}
    throw new Error("Missing return statement in function");
  }

// Integer
  static final public int Integer() throws ParseException {
    jj_consume_token(REG_INT);
                    {if (true) return Integer.parseInt(getToken(0).image);}
    throw new Error("Missing return statement in function");
  }

  static private boolean jj_initialized_once = false;
  /** Generated Token Manager. */
  static public IPTAParserTokenManager token_source;
  static SimpleCharStream jj_input_stream;
  /** Current token. */
  static public Token token;
  /** Next token. */
  static public Token jj_nt;
  static private int jj_ntk;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[14];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x200000,0x8,0x80000,0x80400000,0x40,0x0,0x8000,0x80,0x1e800000,0x0,0x8000,0x20,0x0,0x0,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0x0,0x0,0x0,0x0,0x200,0x200,0x0,0x200,0x0,0x240,0x0,0x200,0xc0,0xc0,};
   }

  /** Constructor with InputStream. */
  public IPTAParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public IPTAParser(java.io.InputStream stream, String encoding) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  ");
      System.out.println("       You must either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new IPTAParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  static public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  static public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
  }

  /** Constructor. */
  public IPTAParser(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser. ");
      System.out.println("       You must either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new IPTAParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
  }

  /** Constructor with generated Token Manager. */
  public IPTAParser(IPTAParserTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser. ");
      System.out.println("       You must either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(IPTAParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 14; i++) jj_la1[i] = -1;
  }

  static private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }


/** Get the next Token. */
  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  static final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.List jj_expentries = new java.util.ArrayList();
  static private int[] jj_expentry;
  static private int jj_kind = -1;

  /** Generate ParseException. */
  static public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[43];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 14; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 43; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  static final public void enable_tracing() {
  }

  /** Disable tracing. */
  static final public void disable_tracing() {
  }

}
